<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <!-- CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="static/styles/prism.css">
    <link rel="stylesheet" type="text/css" href="static/styles/jquery.tabpager.css">
    
    <title>Scene Understanding</title>
</head>

<body>
    <nav class="navbar navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="/"><h3>Scene Understanding 2.1</h3> Using YOLOv5</a>
        </div>
    </nav>

    <div class="container"> 
        <div class="container">
            <br>
            <br>
            
            <div class="row">
                <form action="/upload" method="post" enctype="multipart/form-data">
                    <input type="file" name="image_upload" accept=".jpg,.jpeg,.gif,.png,.jfif" />
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
            </div>

            <br>

        </div>
    </div>

{% if img_show %}

    <div class="container">    
        <div class="row">
            <div class="col-lg">
                <img class="img-thumbnail" src={{img_show}} alt="">
            </div>

            <div class="col-lg">
                <form method="post" action="/output">
                    <button type="submit" class="btn btn-secondary" name="pple" value="pple" {{disabled}}>Press to See Response API</button>
                </form>

                {% if json_output %}
                <div>{{runtime}}</div>
                <div class="card">
                    <div class="card-body">
                        <pre class="prettyprint">
                            {{ json_output }}
                        </pre>
                    </div>
                </div>
                {% endif %}
                
            </div>
        </div>
    </div>
    
{% endif %}

<p>
    <div class="container">
        <section class="code">
            <details>
                <ul id="tab">
                    <li >Python</li>
                </ul>
                <div id="wrapper">
                    <div class="contents">
                        <div>
                            <pre class="line-numbers">
                                <code class="language-python">

import requests
import base64
import json


def SendImageToSceneUnderstandingServer(url, Imagefile, json_data):
    """Sends JSON request to Scene Understanding module and recieve a JSON response

    Args
    ----
    url (str): URL of server where scene understanding module is hosted
    Imagefile (str): filepath of image
    json_data (dict): JSON request with image content set as None

    Rets
    ----
    j (dict): JSON response from scene understanding module
    """
    image = open(Imagefile, 'rb')
    base64_bytes = base64.b64encode(image.read()).decode("utf-8")

    json_data["requests"][0]["image"]["content"] = base64_bytes
    response = requests.post(url, json=json_data)
    json_response = response.content

    j = json.loads(json_response)
    return j


# input variables ------------
Imagefile = 'path/to/image.jpg'
url = 'https://vama.dsldemo.site/v1/sceneunderstanding/{{module}}/api'
json_data = \
{
    "requests": [
        {
            "features": [
            {
                "min_height": 0.03,
                "min_width": 0.03,
                "maxResults": 20,
                "score_th": 0.30,
                "nms_iou": 0.40,
                "type": "HUMAN_DETECTION"
            }
            ],
            "image": {
                "content": None
            }
        }
    ]
}


# call function ------------
j = SendImageToSceneUnderstandingServer(url, Imagefile, json_data)
print(j)

                                </code>
                            </pre>
                        </div>
                    </div>
                            
                </div>
                <summary>Sample code for JSON API call</summary>
            </details>
        </section>
    </div>
</p>

</div>

    <!-- JavaScript -->
    <script type="text/javascript" src="static/scripts/jquery-3.4.1.min.js"></script>
    <script type="text/javascript" src="static/scripts/prism.js"></script>
    <script type="text/javascript" src="static/scripts/jquery.tabpager.js"></script>
    <script type="text/javascript" src="static/scripts/tab.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <!-- syntax highlight for json -->
    <script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>

</body>
